default:
  artifacts:
    expire_in: 1 day

stages:
  - bootstrap

workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE == "web"
      when: always

generate:
  stage: bootstrap
  image: registry.gitlab.com/haondt/cicd/registry/hephaestus:1.0.1
  script:
    - |
      if  [ ! -f pipeline.yml ]; then
        echo "Error: pipeline.yml not found"
        exit 1
      fi
    - git clone --depth 1 https://gitlab.com/haondt/CICD/pipelines ./pipelines
    - echo "generating downstream pipeline"
    - cp pipeline.yml pipelines
    - cd pipelines
    - ROOT_PIPELINE_SOURCE=$CI_PIPELINE_SOURCE python3 generate.py > "../generated_pipeline.yml"
  artifacts:
    paths:
      - generated_pipeline.yml
      - ./pipelines

trigger:
  stage: bootstrap
  needs:
    - generate
  trigger:
    include:
      - artifact: generated_pipeline.yml
        job: generate
    strategy: depend
  variables:
    ROOT_PIPELINE_ID: $CI_PIPELINE_ID
    ROOT_PIPELINE_SOURCE: $CI_PIPELINE_SOURCE
